// this function verifies disk space in kilobytes
function verifyDiskSpace(dirPath, spaceRequired)
{
  var spaceAvailable;

  // Get the available disk space on the given path
  spaceAvailable = fileGetDiskSpaceAvailable(dirPath);

  // Convert the available disk space into kilobytes
  spaceAvailable = parseInt(spaceAvailable / 1024);

  // do the verification
  if(spaceAvailable < spaceRequired)
  {
    logComment("Chom ket plass-disk a-walc'h : " + dirPath);
    logComment("  red : " + spaceRequired + " K");
    logComment("  chom a ra : " + spaceAvailable + " K");
    return(false);
  }

  return(true);
}

// OS type detection
// which platform?
function getPlatform()
{
  var platformStr;
  var platformNode;

  if('platform' in Install)
  {
    platformStr = new String(Install.platform);

    if (!platformStr.search(/^Macintosh/))
      platformNode = 'mac';
    else if (!platformStr.search(/^Win/))
      platformNode = 'win';
    else if (!platformStr.search(/^OS\/2/))
      platformNode = 'win';
    else
      platformNode = 'unix';
  }
  else
  {
    var fOSMac  = getFolder("Mac System");
    var fOSWin  = getFolder("Win System");

    logComment("fOSMac: "  + fOSMac);
    logComment("fOSWin: "  + fOSWin);

    if(fOSMac != null)
      platformNode = 'mac';
    else if(fOSWin != null)
      platformNode = 'win';
    else
      platformNode = 'unix';
  }

  return platformNode;
}


var srDest = 792;
var err;
var fProgram;
var platformNode;

platformNode = getPlatform();
logComment("initInstall: platformNode=" + platformNode);
// end - OS type detection

// --- LOCALIZATION NOTE: translate only these ---
var prettyName = "Brezhoneg";
var langcode = "br";
var regioncode = "FR";
var chromeNode = langcode + "-" + regioncode;
// --- END LOCALIZABLE RESOURCES ---
var regName    = "locales/mozilla/" + chromeNode;
var chromeName = chromeNode + ".jar";
var regionFile = regioncode + ".jar";
var platformName = langcode + "-" + platformNode + ".jar";
var localeName = "locale/" + chromeNode + "/";
var regionName = "locale/" + regioncode + "/";

err = initInstall(prettyName, regName, "1.4.0.2003061711"); 
logComment("initInstall: " + err);

fProgram = getFolder("Program");
logComment("fProgram: " + fProgram);

if (verifyDiskSpace(fProgram, srDest))
{
    var chromeType = LOCALE;
    // DELAYED_CHROME is still needed on many systems for bug 109044
    chromeType |= DELAYED_CHROME;
    err = addDirectory("","bin",fProgram,"");
    logComment("addDirectory() returned: " + err);

    if (err != SUCCESS)
    {
        logComment("addDirectory() to " + fProgram + "failed!");
 
        // couldn't install globally, try installing to the profile

// does not work with DELAYED_CHROME !!!
//        resetError();
//        chromeType |= PROFILE_CHROME;
//        fProgram = getFolder("Profile");
//        logComment("try installing to the user profile:" + fProgram);
//        err = addDirectory("","bin/chrome",fProgram,"chrome");
    }
 
    setPackageFolder(fProgram);
 
    // check return value
    if ((err == SUCCESS) || (err == REBOOT_NEEDED))
    {
        var tellReboot = 0;
        if (err == REBOOT_NEEDED) {
           tellReboot = 1;
           resetError(); err = 0;
        }
        // register chrome
        var cf = getFolder(fProgram, "chrome/"+chromeName);
        var pf = getFolder(fProgram, "chrome/"+platformName);
        var rf = getFolder(fProgram, "chrome/"+regionFile);

        registerChrome(chromeType, cf, localeName + "global/");
        registerChrome(chromeType, cf, localeName + "communicator/");
        registerChrome(chromeType, cf, localeName + "content-packs/");
        registerChrome(chromeType, cf, localeName + "cookie/");
        registerChrome(chromeType, cf, localeName + "editor/");
        registerChrome(chromeType, cf, localeName + "help/");
        registerChrome(chromeType, cf, localeName + "messenger/");
        registerChrome(chromeType, cf, localeName + "messenger-mdn/");
        registerChrome(chromeType, cf, localeName + "messenger-smime/");
        registerChrome(chromeType, cf, localeName + "mozldap/");
	registerChrome(chromeType, cf, localeName + "autoconfig/");
        registerChrome(chromeType, cf, localeName + "navigator/");
        registerChrome(chromeType, cf, localeName + "necko/");
        registerChrome(chromeType, cf, localeName + "p3p/");
        registerChrome(chromeType, cf, localeName + "pipnss/");
        registerChrome(chromeType, cf, localeName + "pippki/");
        registerChrome(chromeType, cf, localeName + "wallet/");

        registerChrome(chromeType, pf, localeName + "global-platform/");
        registerChrome(chromeType, pf, localeName + "communicator-platform/");
        registerChrome(chromeType, pf, localeName + "navigator-platform/");
        if (platformNode == "win") {
          registerChrome(chromeType, pf, localeName + "messenger-mapi/");
        }

//        registerChrome(chromeType, rf, regionName + "global-region/");
//        registerChrome(chromeType, rf, regionName + "communicator-region/");
//        registerChrome(chromeType, rf, regionName + "editor-region/");
//        registerChrome(chromeType, rf, regionName + "messenger-region/");
//        registerChrome(chromeType, rf, regionName + "navigator-region/");

        err = performInstall(); 
        logComment("performInstall() returned: " + err);
        if (err == REBOOT_NEEDED) {
           tellReboot = 1;
           resetError(); err = 0;
        }
        if (err == SUCCESS)
        {
           if (tellReboot == 1)
           {
               alert("Deuet a-benn da enstali\u00F1 ar bakadenn brezhoneg. Red vo deoc'h ADLA\u00D1SA\u00D1 ho sistem a-raog galloud kemer ar yezh dre Edit > Preferences (Rumm: Appearance > Languages/Content).");
           }
           else
           {
               alert("Deuet a-benn da enstali\u00F1 ar bakadenn brezhoneg.  Red vo deoc'h ADLA\u00D1SA\u00D1 Mozilla a-raog galloud kemer ar yezh dre Edit > Preferences (Rumm: Appearance > Languages/Content).");
           }
        }
        else
        {
               alert("An enstali\u00F1 en-deus c'hwitet. Kod ar fa\u017Ci a oa " + err + ".");
        }
    }
    else
    {
        cancelInstall(err);
        logComment("cancelInstall due to error: " + err);
        if (err == -202) {
           alert("An enstali\u00F1 zo bet nullet gand ar fa\u017Ci " + err +". N'ho-peus ket an aer da gaoud droajo\u00F9-skrivi\u00F1 e-barzh an directory 'chrome' deus Mozilla. Enstalit evel root/merour-sistem, mar plij.");
        }
        else {
           alert("An enstali\u00F1 zo bet nullet. Kod ar fa\u017Ci a oa " + err + ".");
        }
    }
}
else
    cancelInstall(INSUFFICIENT_DISK_SPACE);
